//+------------------------------------------------------------------+
//| TD Sequential.mq4 |
//| Copyright  Bars4, MetaQuotes Software Corp. |
//| http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "clam61"
#property link "http://www.forexfactory.com/forexforum/showthread.php?t=8915&page=1&pp=15"
#property indicator_chart_window

#property indicator_buffers 6
#property indicator_color1 Green
#property indicator_color2 Green
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_color5 Red
#property indicator_color6 Blue

//---- input parameters
//spacing between text
extern int spacing=25;

extern int numBars = 1000;

//colors of low and high boundaries for bullish setups
extern color inputExtremeColor = Green;

//color of setup numbers for bullish setups
extern color inputSetupColor = Green;

//color of countdown numbers for bullish setups
extern color inputCountdownColor = Yellow;

//----------------- Bearish -----------------
//colors of low and high boundaries for bearish setups
extern color inputBearishExtremeColor = Red;

//color of setup numbers for bullish setups
extern color inputBearishSetupColor = Red;

//color of countdown numbers for bullish setups
extern color inputBearishCountdownColor = HotPink;
//----------------- Bearish -----------------

//display the setup and countdown numbers
extern bool showNumbers = false;

//show a special symbol for a perfect 9 day setup
extern bool show_perfected_9_day_setup = true;

//show a special symbol for a perfect 13 day setup
extern bool show_entry_on_13 = true;

//show a special symbol for a 4 bar flip
extern bool show_entry_on_4_flip = true;

//show a special symbol for a 2 bar flip
extern bool show_entry_on_2_flip = true;

//the setup number
int setup = 0;

//----------------- Bearish -----------------
int bearishSetup = 0;
int sell9Arrow[];
int sellSetup[];
string sellCountdown[];
int perfected9SellP[];
int entryOn13SellArrow[];
int Flip2EntrySell[];
int Flip4EntrySell[];
int sellX[];
int objectSellList[];
int perfected13SellP[];
//----------------- Bearish -----------------

//array to hold buy setup numbers
int buySetup[];

//arrays to hold buy countdown numbers
string buyCountdown[];

//arrays to hold symbols
int perfected9BuyP[];
int buy9Arrow[];
int entryOn13Arrow[];
int Flip2EntryBuy[];
int Flip4EntryBuy[];
int buyX[];
int objectList[];
int perfected13BuyP[];

//-- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];

//----------------- Bearish -----------------
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
//----------------- Bearish -----------------

//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init() {

  SetIndexStyle(0,DRAW_LINE, STYLE_DOT, 1, inputExtremeColor);
  SetIndexBuffer(0,ExtMapBuffer1);
  SetIndexStyle(1,DRAW_LINE, STYLE_DOT, 1, inputExtremeColor);
  SetIndexBuffer(1,ExtMapBuffer2);
  SetIndexStyle(2,DRAW_LINE);
  SetIndexBuffer(2,ExtMapBuffer3);

//----------------- Bearish -----------------
  SetIndexStyle(3,DRAW_LINE, STYLE_DOT, 1, inputBearishExtremeColor);
  SetIndexBuffer(3,ExtMapBuffer4);
  SetIndexStyle(4,DRAW_LINE, STYLE_DOT, 1, inputBearishExtremeColor);
  SetIndexBuffer(4,ExtMapBuffer5);
  SetIndexStyle(5,DRAW_LINE);
  SetIndexBuffer(5,ExtMapBuffer6);
//----------------- Bearish -----------------
  ArrayResize(buy9Arrow, Bars);  
  ArrayResize(buySetup, Bars);
  ArrayResize(buyCountdown, Bars);
  ArrayResize(perfected13BuyP, Bars);
  ArrayResize(perfected9BuyP, Bars);
  ArrayResize(entryOn13Arrow, Bars);
  ArrayResize(Flip2EntryBuy, Bars);
  ArrayResize(Flip4EntryBuy, Bars);
  ArrayResize(buyX, Bars);
  ArrayResize(objectList, Bars);
  
//----------------- Bearish -----------------
  ArrayResize(sell9Arrow, Bars);
  ArrayResize(sellSetup, Bars);
  ArrayResize(sellCountdown, Bars);
  ArrayResize(perfected13SellP, Bars);
  ArrayResize(perfected9SellP, Bars);
  ArrayResize(entryOn13SellArrow, Bars);
  ArrayResize(Flip2EntrySell, Bars);
  ArrayResize(Flip4EntrySell, Bars);
  ArrayResize(sellX, Bars);
  ArrayResize(objectSellList, Bars);
//----------------- Bearish -----------------

  return(0);
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function |
//+------------------------------------------------------------------+
int deinit() {
  
  for(int i = 0; i < Bars; i++) {
    ObjectDelete(""+i);
    ObjectDelete("perfectedbuyp"+i);
	 ObjectDelete("perfected13BuyP"+i);
//	 ObjectDelete("square"+i);
    ObjectDelete("buy9Arrow"+i);
	 ObjectDelete("sellx"+i);
	 ObjectDelete("x"+i);
	 ObjectDelete("Flip2EntryBuy"+i);
	 ObjectDelete("Flip4EntryBuy"+i);
	 ObjectDelete("entryOn13Arrow"+i);
	 for (int j = 0; j < objectList[i]; j++)
	 ObjectDelete("count"+i+j);

//----------------- Bearish -----------------
    ObjectDelete("sell"+i);
    ObjectDelete("sell9Arrow"+i);
    ObjectDelete("perfectedsellp"+i);
	 ObjectDelete("perfected13SellP"+i);
	 ObjectDelete("sellx"+i);
	 ObjectDelete("Flip2EntrySell"+i);
	 ObjectDelete("Flip4EntrySell"+i);
	 ObjectDelete("entryOn13SellArrow"+i);
    for (j = 0; j < objectSellList[i]; j++)
	 ObjectDelete("sellcount"+i+j);
//----------------- Bearish -----------------

	 Comment("");
  }	

  return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function |
//+------------------------------------------------------------------+
int start() {

  Comment("Please report any and all bugs to\nhttp://www.forexfactory.com/forexforum/showthread.php?t=8915&page=1&pp=15");

  if(numBars < 0) 
    numBars = 0;
    
  int limit = Bars - numBars;

  // For all Bars starting from the earliest
  for(int i = limit; i >= 0; i--) {

    // If this is the first bar in the sequence and previous bar is greater than or equal to the close four Bars ago,
    // draw a P over the previous bar    
    if (setup == 0 && Close[i] < Close[i+4] && Close[i+1] > Close[i+5]) {
    
      //clear the stop line
      clearBullStop(i);
    
      //increment the setup number
      setup++;
      
      //set the buffer
      buySetup[i] = setup;
    }
    // If close of this bar is lower then the close 4 Bars ago
    else if (setup > 0 && Close[i] < Close[i+4]) {
    
      //increment the number
      setup++;
      
      //set the buffer
      buySetup[i] = setup;
      
      if (setup == 9)
        //draw an arrow
        buy9Arrow[i] = 1;
                
      //if setup day 9, check to see if intersection happened on day 8, if so start countdown on day 9
      if (setup == 9 && intersect(i+1)) {
        //draw an arrow
        buy9Arrow[i] = 1;
        
        //if in the setup and we have a perfected setup, draw an up arrow 
        //bar 8 or 9 less than bar 6 or 7
        if (show_perfected_9_day_setup && (Low[i] < Low[i+2] || Low[i] < Low[i+3] || Low[i+1] < Low[i+2] || Low[i+1] < Low[i+3])) 
          perfected9BuyP[i] = 1;

        //Perform the countdown
        TD_Countdown(i, getArrayMax(High, i, buySetup[i]), getArrayMin(Low, i, buySetup[i]), i + 8);
        
        //set the setup to 0
        setup = 0;
      }
      //if after day 8 and if this day intersects
      else if (setup > 8 && intersect(i)) {
        
        //start countdown on the next day
        TD_Countdown(i-1, getArrayMax(High, i, buySetup[i]), getArrayMin(Low, i, buySetup[i]), i + setup - 1);
        
        //set the setup to 0
        setup = 0;
      } 
    }
    // Otherwise
    else 
      //restart the setup
      setup = 0; 
      
      
    //----------BEARISH----------------
    // If this is the first bar in the sequence and previous bar is less than the close four Bars ago,
    if (bearishSetup == 0 && Close[i] > Close[i+4] && Close[i+1] < Close[i+5]) {
    
      //clear the stop line
      clearBearStop(i);
    
      //increment the setup number
      bearishSetup++;
      
      //set the buffer
      sellSetup[i] = bearishSetup;
    }
    // If close of this bar is greater than the close 4 Bars ago
    else if (bearishSetup > 0 && Close[i] > Close[i+4]) {
            
      //increment the number
      bearishSetup++;
      
      //set the buffer
      sellSetup[i] = bearishSetup;
      
      if (bearishSetup == 9)
        //draw an arrow
        sell9Arrow[i] = 1;
        
      //if setup day 9, check to see if intersection happened on day 8, if so start countdown on day 9
      if (bearishSetup == 9 && sellIntersect(i+1)) {

        //if in the setup and we have a perfected sell setup, draw a down arrow 
        //bar 8 or 9 less than bar 6 or 7
        if (show_perfected_9_day_setup && (High[i] > High[i+2] || High[i] > High[i+3] || High[i+1] > High[i+2] || High[i+1] > High[i+3])) 
          perfected9SellP[i] = 1;

        //Perform the countdown
        TD_SellCountdown(i, getArrayMax(High, i, sellSetup[i]), getArrayMin(Low, i, sellSetup[i]), i + 8);
        
        //set the setup to 0
        bearishSetup = 0;
      }
      //if after day 8 and if this day intersects
      else if (bearishSetup > 8 && sellIntersect(i)) {
        
        //start countdown on the next day
        TD_SellCountdown(i-1, getArrayMax(High, i, sellSetup[i]), getArrayMin(Low, i, sellSetup[i]), i + bearishSetup - 1);
        
        //set the setup to 0
        bearishSetup = 0;
      } 
    }
    // Otherwise
    else { 
      //restart the setup
      bearishSetup = 0;      
      }
    //----------BEARISH----------------     
  }

  //Draw the stuff
  for (int k = limit; k >= 0; k--) {

    //Draw the buy setup #s
    
    //If buy setup is marked for this bar and showNumbers is true
    if (buySetup[k] > 0 && showNumbers) {
    
      //Create the text object
      ObjectCreate(""+k, OBJ_TEXT, 0, Time[k],Low[k]-(objectList[k]+1)*spacing*Point);
    
      //Draw the #s
      ObjectSetText(""+k, ""+DoubleToStr(buySetup[k],0), 8, "Arial", inputSetupColor);

      //Add to the object list for this bar
      objectList[k]++;
    }
    if (StringLen(buyCountdown[k]) > 0 && showNumbers) {
      //split the string
      string arr[0];
      split(buyCountdown[k], ',', arr);
      
      for (int l = 0; l < ArraySize(arr); l++) {
        ObjectCreate("count"+k + l, OBJ_TEXT, 0, Time[k],Low[k]-(objectList[k]+1)*spacing*Point );
        ObjectSetText("count"+k + l, arr[l], 8, "Arial", inputCountdownColor);
        objectList[k]++;      
      }
    }

    //Draw the square.
    //If the previous bar was a setup bar greater than 8, and the current bar is not, the setup just ended
    //Draw a box encompassing the setup with a label of the high and low of the box
    if (buySetup[k + 1] > 8 && buySetup[k] == 0) {
      //Get the extreme high from all setup Bars
      double high = getArrayMax(High, k + 1, buySetup[k+1]);
      double low = getArrayMin(Low, k + 1, buySetup[k+1]);

      //Draw the rectangle, surrounding the setup
      drawExtremes(k+1, buySetup[k+1]-1, high, low);
      //Print("high: " + high +", low: " + low);
      //ObjectCreate("square"+k, OBJ_RECTANGLE, 0, Time[k + buySetup[k+1]], extremeLow, Time[k + 1], extremeHigh );
      //ObjectSet("square"+k,OBJPROP_COLOR, inputSquareColor);
    }
    
    //Draw the P's
    if (perfected13BuyP[k] == 1) {
      ObjectCreate("perfected13BuyP"+k, OBJ_TEXT, 0, Time[k],Low[k]-(objectList[k]+1)*spacing*Point );
      ObjectSetText("perfected13BuyP"+k, "P", 10, "Arial Black", inputCountdownColor);
      objectList[k]++;
    }

    if (perfected9BuyP[k] == 1) {
      ObjectCreate("perfectedbuyp"+k, OBJ_TEXT, 0, Time[k],Low[k]-(objectList[k]+1)*spacing*Point);
      ObjectSetText("perfectedbuyp"+k, "P", 10, "Arial Black", inputSetupColor);
      objectList[k]++;
    }

    if (buy9Arrow[k] == 1) {
      ObjectCreate("buy9Arrow"+k, OBJ_ARROW, 0, Time[k],Low[k]-(objectList[k]+1)*spacing*Point);
      ObjectSet("buy9Arrow"+k, OBJPROP_ARROWCODE, 225);
      ObjectSet("buy9Arrow"+k, OBJPROP_COLOR, inputSetupColor);
      objectList[k]++;
    }
    
    if (Flip2EntryBuy[k] == 1) {
      ObjectCreate("Flip2EntryBuy"+k, OBJ_ARROW, 0, Time[k],Low[k]-(objectList[k]+1)*spacing*Point);
      ObjectSet("Flip2EntryBuy"+k, OBJPROP_ARROWCODE, 233);
      ObjectSet("Flip2EntryBuy"+k, OBJPROP_COLOR, inputSetupColor);
      objectList[k]++;
    }
    
    if (Flip4EntryBuy[k] == 1) {
      ObjectCreate("Flip4EntryBuy"+k, OBJ_ARROW, 0, Time[k],Low[k]-(objectSellList[k]+1)*spacing*Point);
      ObjectSet("Flip4EntryBuy"+k, OBJPROP_ARROWCODE, 241);
      ObjectSet("Flip4EntryBuy"+k, OBJPROP_COLOR, inputSetupColor);
      objectList[k]++;
    }    

    if (entryOn13Arrow[k] == 1) {
      ObjectCreate("entryon13arrow"+k, OBJ_ARROW, 0, Time[k],Low[k]-(objectList[k]+1)*spacing*Point);
      ObjectSet("entryon13arrow"+k, OBJPROP_ARROWCODE, 225);
      ObjectSet("entryon13arrow"+k, OBJPROP_COLOR, inputCountdownColor);
      objectList[k]++;
    }
        
    if (buyX[k] == 1) {
      ObjectCreate("x"+k, OBJ_ARROW, 0, Time[k],Low[k]-(objectList[k]+1)*spacing*Point);
      ObjectSet("x"+k, OBJPROP_ARROWCODE, SYMBOL_STOPSIGN);
      ObjectSet("x"+k, OBJPROP_COLOR, inputCountdownColor);
      objectList[k]++;
    }

    //------------------BEARISH-------------------------
    //Draw the sell setup #s
    
    //If buy setup is marked for this bar and showNumbers is true
    if (sellSetup[k] > 0 && showNumbers) {
    
      //Create the text object
      ObjectCreate("sell"+k, OBJ_TEXT, 0, Time[k],High[k]+2*(objectSellList[k]+1)*spacing*Point);
    
      //Draw the #s
      ObjectSetText("sell"+k, ""+DoubleToStr(sellSetup[k],0), 8, "Arial", inputBearishSetupColor);

      //Add to the object list for this bar
      objectSellList[k]++;
    }
    if (StringLen(sellCountdown[k]) > 0 && showNumbers) {
      //split the string
      string arr2[0];
      split(sellCountdown[k], ',', arr2);
      
      for (l = 0; l < ArraySize(arr2); l++) {
        ObjectCreate("sellcount"+k + l, OBJ_TEXT, 0, Time[k],High[k]+2*(objectSellList[k]+1)*spacing*Point );
        ObjectSetText("sellcount"+k + l, arr2[l], 8, "Arial", inputBearishCountdownColor);
        objectSellList[k]++;      
      }
    }

    //Draw the square.
    //If the previous bar was a setup bar greater than 8, and the current bar is not, the setup just ended
    //Draw a box encompassing the setup with a label of the high and low of the box
    if (sellSetup[k + 1] > 8 && sellSetup[k] == 0) {
      //Get the extreme high from all setup Bars
      high = getArrayMax(High, k + 1, sellSetup[k+1]);
      low = getArrayMin(Low, k + 1, sellSetup[k+1]);
//Print("Setup # before is " + sellSetup[k+1]);
//Print("before: high is " + high + " low is " + low + " at " + getDateFromTime(Time[k+1]));
      //Draw the rectangle, surrounding the setup
      drawBearishExtremes(k+1, sellSetup[k+1]-1, high, low);
      //Print("high: " + high +", low: " + low);
      //ObjectCreate("square"+k, OBJ_RECTANGLE, 0, Time[k + buySetup[k+1]], extremeLow, Time[k + 1], extremeHigh );
      //ObjectSet("square"+k,OBJPROP_COLOR, inputSquareColor);
    }
    
    //Draw the P's
    if (perfected13SellP[k] == 1) {
      ObjectCreate("perfected13SellP"+k, OBJ_TEXT, 0, Time[k],High[k]+2*(objectSellList[k]+1)*spacing*Point );
      ObjectSetText("perfected13SellP"+k, "P", 10, "Arial Black", inputBearishCountdownColor);
      objectSellList[k]++;
    }

    if (perfected9SellP[k] == 1) {
      ObjectCreate("perfectedsellp"+k, OBJ_TEXT, 0, Time[k],High[k]+2*(objectSellList[k]+1)*spacing*Point);
      ObjectSetText("perfectedsellp"+k, "P", 10, "Arial Black", inputBearishSetupColor);
      objectSellList[k]++;
    }

    if (sell9Arrow[k] == 1) {
      ObjectCreate("sell9Arrow"+k, OBJ_ARROW, 0, Time[k],High[k]+2*(objectSellList[k]+1)*spacing*Point);
      ObjectSet("sell9Arrow"+k, OBJPROP_ARROWCODE, 226);
      ObjectSet("sell9Arrow"+k, OBJPROP_COLOR, inputBearishSetupColor);
      objectSellList[k]++;
    }
    
    if (Flip2EntrySell[k] == 1) {
      ObjectCreate("Flip2EntrySell"+k, OBJ_ARROW, 0, Time[k],High[k]+2*(objectSellList[k]+1)*spacing*Point);
      ObjectSet("Flip2EntrySell"+k, OBJPROP_ARROWCODE, 234);
      ObjectSet("Flip2EntrySell"+k, OBJPROP_COLOR, inputBearishSetupColor);
      objectSellList[k]++;
    }
    
    if (Flip4EntrySell[k] == 1) {
      ObjectCreate("Flip4EntrySell"+k, OBJ_ARROW, 0, Time[k],High[k]+2*(objectSellList[k]+1)*spacing*Point);
      ObjectSet("Flip4EntrySell"+k, OBJPROP_ARROWCODE, 242);
      ObjectSet("Flip4EntrySell"+k, OBJPROP_COLOR, inputBearishSetupColor);
      objectSellList[k]++;
    }    

    if (entryOn13SellArrow[k] == 1) {
      ObjectCreate("entryon13sellarrow"+k, OBJ_ARROW, 0, Time[k],High[k]+2*(objectSellList[k]+1)*spacing*Point);
      ObjectSet("entryon13sellarrow"+k, OBJPROP_ARROWCODE, 226);
      ObjectSet("entryon13sellarrow"+k, OBJPROP_COLOR, inputBearishCountdownColor);
      objectSellList[k]++;
    }
        
    if (sellX[k] == 1) {
      ObjectCreate("sellx"+k, OBJ_ARROW, 0, Time[k],High[k]+2*(objectSellList[k]+1)*spacing*Point);
      ObjectSet("sellx"+k, OBJPROP_ARROWCODE, SYMBOL_STOPSIGN);
      ObjectSet("sellx"+k, OBJPROP_COLOR, inputBearishCountdownColor);
      objectSellList[k]++;
    }
    //------------------BEARISH-------------------------
  }
  
  return(0);
}

//check for intersection
//the high of day 9 or 8 is greather than or equal to the Low
//3 days earlier up to day 1 of setup
bool intersect (int startDay) {

  int setupDay = buySetup[startDay];
  
  for (int i = 0; i < setupDay - 3; i++) {
    if (High[startDay] >= Low[startDay + i + 3])
      return (true);
  }
  
  return (false);
}

//check for intersection
//the high of day 9 or 8 is less than or equal to the Low
//3 days earlier up to day 1 of setup
bool sellIntersect (int startDay) {

  int setupDay = sellSetup[startDay];
  
  for (int i = 0; i < setupDay - 3; i++) {
    if (Low[startDay] <= High[startDay + i + 3])
      return (true);
  }
  
  return (false);
}

void TD_SellCountdown(int startDay, double extremeHigh, double extremeLow, int setupStart) {
  //reset the countdown to 0
  int countdown = 0;
  int endCountdown;
  
  //has the 2 flip happened yet
  bool flip2 = false;
  //has the 4 flip happened yet
  bool flip4 = false;
      
  //loop through Bars to find 13 closes that are higher or equal to a close at least two Bars ago
  for (int j = startDay; j >= 0; j--) {  
    if (countdown < 13) {
      //make sure this days close is not greater than the max low of the setup
      if (Close[j] < extremeLow) {
        sellX[j] = 1;
        break;
      }
      
      //make sure a setup does not start again in this direction
      if (Close[j] > Close[j+4] && Close[j+1] < Close[j+5]) {
        sellX[j] = 1;  
        break;
      }
      
      //make sure a setup does not occur in the opposite direction
      else if (Close[j] < Close[j+4] && Close[j+1] > Close[j+5]) {
        sellX[j] = 1;
        break;
      }
        
      if (Close[j] >= Low[j+2]) {  
        countdown++;
          
        if (StringLen(sellCountdown[j]) > 0) {
          string temp = sellCountdown[j] + DoubleToStr(countdown,0) + ",";
          sellCountdown[j] = temp;
        }
        else
          sellCountdown[j] = DoubleToStr(countdown, 0)+",";
      }
            
      //if you have got 13, then exit
      if (countdown == 13) {
        //if you want, show arrow here
        if (show_entry_on_13) 
          entryOn13SellArrow[j] = 1;
          
        //if perfected 13 sell
      if (Low[j] >= Close[j+5])
        perfected13SellP[j] = 1;
      
      endCountdown = j;
      }
    }
    //after the 13 countdown, check for setups
    else {
      // if 2 flip has not happened, and show 2 flip entries are ok, and 2 flip occurred
      if (!flip2 && show_entry_on_2_flip && Close[j] < Close[j+2]) {
        flip2 = true;
        Flip2EntrySell[j] = 1;
      }
      
      // if 4 flip has not happened, and show 4 flip entries are ok, and 4 flip occurred
      if (!flip4 && show_entry_on_4_flip && Close[j] < Close[j+4]) {
        flip4 = true;
        Flip4EntrySell[j] = 1;
        break;
      }
    }
  }
  
  //if you got to 13
  if (countdown == 13) {
    //get the stop loss
    //get the high from the countdown period and setup period
    double high = getArrayMax(High, endCountdown, setupStart - endCountdown);
  
    int highIndex = ArrayMaximum(High, setupStart - endCountdown, endCountdown);
    
    //get the low between the high of that Day and the close of the day before
    double low = MathMin(Low[highIndex], Close[highIndex + 1]);
    
    double range = high - low;
  
    drawBearStop(setupStart, high + range);
  }
}

//countdown, makes sure that no close is higher than any high of setup phase
void TD_Countdown(int startDay, double extremeHigh, double extremeLow, int setupStart) {
  //reset the countdown to 0
  int countdown = 0;
  int endCountdown;
  
  //has the 2 flip happened yet
  bool flip2 = false;
  //has the 4 flip happened yet
  bool flip4 = false;
      
  //loop through Bars to find 13 closes that are lower or equal to a close at least two Bars ago
  for (int j = startDay; j >= 0; j--) {  
    if (countdown < 13) {
      //make sure this days close is not greater than the max high of the setup
      if (Close[j] > extremeHigh) {
  
        buyX[j] = 1;
        break;
      }
      
      //make sure a setup does not start again in this direction
      if (Close[j] < Close[j+4] && Close[j+1] > Close[j+5]) {
        buyX[j] = 1;  
        break;
      }
              
      //make sure a setup does not occur in the opposite direction
      else if (Close[j] > Close[j+4] && Close[j+1] < Close[j+5]) {
        buyX[j] = 1;
        break;
      }

      //if you have got 13, then exit
      if (countdown == 13) {
        //if you want, show arrow here
        if (show_entry_on_13) 
          entryOn13Arrow[j] = 1;
          
        //if perfected 13 buy
      if (Low[j] <= Close[j+5])
        perfected13BuyP[j] = 1;
      
      endCountdown = j;
      }
    }
    //after the 13 countdown, check for setups
    else {
      // if 2 flip has not happened, and show 2 flip entries are ok, and 2 flip occurred
      if (!flip2 && show_entry_on_2_flip && Close[j] > Close[j+2]) {
        flip2 = true;
        Flip2EntryBuy[j] = 1;
      }
      
      // if 4 flip has not happened, and show 4 flip entries are ok, and 4 flip occurred
      if (!flip4 && show_entry_on_4_flip && Close[j] > Close[j+4]) {
        flip4 = true;
        Flip4EntryBuy[j] = 1;
        break;
      }
    }
  }
  
  //if you got to 13
  if (countdown == 13) {
    //get the stop loss
    //get the low from the countdown period and setup period
    double low = getArrayMin(Low, endCountdown, setupStart - endCountdown);
  
    int lowIndex = ArrayMinimum(Low, setupStart - endCountdown, endCountdown);
    
    //get the max between the high of that Day and the close of the day before
    double high = MathMax(High[lowIndex], Close[lowIndex + 1]);
    
    double range = high - low;
  
    drawStop(setupStart, low - range);
  }

}


//Not a true utility function, this is assumes 0 is minimum because we are dealing with prices
double getArrayMin(double array[], int startIndex, int count) {
  //return (array[ArrayMinimum(array, startIndex, count)]);
  double min;
 
  for (int i = startIndex; i < startIndex + count; i++) {

    if (i == startIndex) {
      min = MathMin(array[i], array[i + 1]);
    }
    else {
      min = MathMin(array[i], min);
    }
  }
  
  return (min);
}

//Not a true utility function, this is assumes 0 is minimum because we are dealing with prices
double getArrayMax(double array[], int startIndex, int count) {
  //return (array[ArrayMaximum(array, startIndex, count)]);
  double max;
 
  for (int i = startIndex; i < startIndex + count; i++) {

    if (i == startIndex) {
      max = MathMax(array[i], array[i + 1]);
    }
    else {
      max = MathMax(array[i + 1], max);
    }
  }
  
  return (max);
}

void split(string s, int delimiter, string &arr[]) {
  int begin = 0;
  int length = 0;
  int size = 0;
 
  for (int i = 0; i < StringLen(s); i++) {
    if (delimiter == StringGetChar(s, i)) {
      size++;
      length = i - begin;
      ArrayResize(arr, size);
      arr[size-1] = StringSubstr(s, begin, length);
      begin = i + 1;
    }
  }
  
  return;
}

string getDateFromTime(int date) {
  return (TimeYear(date)+"."+TimeMonth(date) + "." + TimeDay(date));
}

void drawExtremes(int start, int length, double h, double l) {
  for (int i = start; i <= start + length; i++) {
    ExtMapBuffer1[i] = h;
    ExtMapBuffer2[i] = l;
    
  }
}

void drawBearishExtremes(int start, int length, double h, double l) {
//Print("length is " + length + " high is " + h + " low is " + l + " at " + getDateFromTime(Time[start]));
  for (int i = start; i <= start + length; i++) {
  
    ExtMapBuffer4[i] = h;
    ExtMapBuffer5[i] = l;
    
  }
}

void drawStop(int start, double value) {
  for (int i = start; i >= 0; i--) {
    ExtMapBuffer3[i] = value;
  }
 
}

void clearBullStop(int start) {
  for (int i = start; i >= 0; i--) {
    ExtMapBuffer3[i] = EMPTY_VALUE;
  }
    
}

void drawBearStop(int start, double value) {
  for (int i = start; i >= 0; i--) {
    ExtMapBuffer6[i] = value;
  }
 
}
void clearBearStop(int start) {
  for (int i = start; i >= 0; i--) {
    ExtMapBuffer6[i] = EMPTY_VALUE;
  }
}